function [t,q,HcamWorld,Htarget] = cameraPoseEstimation( method )

[p2d, p3d, target, K] = calibrationData(4);
[dim,n] = size(p3d);
p2dStart = p2d;

% bring image points on the normalized image plane (z=1)
p2d(3,:) = ones(1,n);
p2d = inv(K) * p2d;
for k=1:n
    p2d(1,k) = p2d(1,k) / p2d(3,k);
    p2d(2,k) = p2d(2,k) / p2d(3,k);
    p2d(3,k) = 1;
end

% options for the pose estimator
options.tol = 0.00001;
options.epsiolon = 0.000001;
options.method = method;

[R, t, it, obj_err, img_err] = objpose(p3d(1:3,:), p2d(1:2,:),options );
obj_err;
img_err;
q = mat2quat(R);

H(1:3,1:3) = R; H(1:3,4) = t; H(4,1:3) = 0; H(4,4) = 1;
HcamWorld = inv(H);

Htarget = euler2artMatrix(target(3:6),target(1:3));

%plot projection of points
p3d(4,:) = ones(1,n);
p3dCamFrame = H*p3d;
p2proj = K * p3dCamFrame(1:3,:);
figure(1);
plotHomo2(p2proj,'bo');
hold on;
plot(p2dStart(1,:),p2dStart(2,:),'rx');