function [R] = euler2artMatrix(x,t)

x = x*pi/180;

cz = cos(x(3));     cy = cos(x(2));     cx = cos(x(1));
sz = sin(x(3));     sy = sin(x(2));     sx = sin(x(1));

R(1,:) = [cz*cy, -sz*cy, sy, t(1) ];
R(2,:) = [sz*cx + cz*sy*sx, cz*cx-sz*sy*sx, -cy*sx, t(2)];
R(3,:) = [sz*sx - cz*sy*cx, cz*sx+sz*sy*cx, cy*cx, t(3)];
R(4,:) = [0 0 0 1];


% conversion to euler angles (buggy)
z = atan2( -R(1,2),R(1,1) ) * 180/pi;
y = asin(R(1,3)) * 180/pi;
x = atan2( -R(2,3),R(3,3) ) * 180/pi;