function [Q] = mat2quat(R)

%conversion to quaternion
%checking for largest diagonal element

c = 1;
q(1) = (1 + R(1,1) + R(2,2) + R(3,3)) / 4;
q(2) = (1 + R(1,1) - R(2,2) - R(3,3)) / 4;
if q(1) < q(2)
    c = 2;
end
q(3) = (1 - R(1,1) + R(2,2) - R(3,3)) / 4;
if q(c) < q(3)
    c = 3;
end
q(4) = (1 - R(1,1) - R(2,2) + R(3,3)) / 4;
if q(c) < q(4)
    c = 4;
end

% computing off-diagonal elements
q01 = (R(3,2) - R(2,3)) / 4;
q02 = (R(1,3) - R(3,1)) / 4;
q03 = (R(2,1) - R(1,2)) / 4;
q12 = (R(1,2) + R(2,1)) / 4;
q13 = (R(1,3) + R(3,1)) / 4;
q23 = (R(2,3) + R(3,2)) / 4;

if c == 1
    q(1) = sqrt(q(1));
    q(2) = q01 / q(1);
    q(3) = q02 / q(1);
    q(4) = q03 / q(1);
elseif c == 2
    q(2) = sqrt(q(2));
    q(1) = q01 / q(2);
    q(3) = q12 / q(2);
    q(4) = q13 / q(2);
elseif c == 3
    q(3) = sqrt(q(3));
    q(1) = q02 / q(3);
    q(2) = q12 / q(3);
    q(4) = q23 / q(3);    
elseif c == 4
    q(4) = sqrt(q(4));
    q(1) = q03 / q(4);
    q(2) = q13 / q(4);
    q(3) = q23 / q(4);    
end

Q = q;